#include "stdafx.h"
#include "RemoveInstallModule.h"
#include <Atlpath.h>
#include "IPC/IPCCopyData.h"
#include "AgentDLL.h"
#include "LauncherManager.h"
#include "util.h"

const TCHAR *IDS_TIP_INSTALL_UNINSTALLER_OPTION = _T("_?=%s");

class MyRemoveEventCallback : public IIPCReceiveCallback
{
public:
	MyRemoveEventCallback() : m_packetType(PacketCommand_Uninstall), m_status(0)
	{
		m_handle = ::CreateEvent( NULL, TRUE, FALSE, NULL );
	}

	int Callback(IPCPacket& packet, IIPCHandle *callback_handle )
	{
		ExecuteStatusPacket *pHeader = (ExecuteStatusPacket *)packet.data;

		m_packetType	= pHeader->type;
		m_status		= pHeader->status;

		packet.Release();
		SetEvent( m_handle );
		return 1;
	}

	int GetStatus()
	{
		return m_status;
	}

	HANDLE GetHandle()
	{
		return m_handle;
	}

	DWORD GetCommand()
	{
		return m_packetType;
	}

private:
	int			m_status;
	DWORD		m_packetType;
	HANDLE		m_handle;
};

BOOL CopyFileToTemp( const TCHAR *source, const TCHAR *target )
{
	return ::CopyFile( source, target, FALSE );
}

BOOL RemoveProgram( int installer_type, const TCHAR *guid, const TCHAR *path, const TCHAR *param, int execute_option )
{
	IIPCHandle* launcherHandle = LauncherManager::GetInstance()->GetLauncherHandle();
	if( NULL == launcherHandle )
	{
		return FALSE;
	}

	HANDLE waitProcessHandle = NULL;
	TCHAR filename[1024];

	TCHAR target_path[1024] = {0, };
	TCHAR str_execute_option[1024] = { 0, };
	TCHAR execution_option[1024] = {0, };

	CString para = _T("/NT ");
	if( (execute_option & NUPDATE_TYPE_SILENT) == NUPDATE_TYPE_SILENT )
	{
		para += _T("/M ");
	}

	//Change 2009-02-17
	//ȹ Ƿ      ϱ  /O ɼ 
	//̽ BTS-131  ּ óմϴ.
//    	if( (execute_option & NUPDATE_TYPE_NOEXTRAWORK) == NUPDATE_TYPE_NOEXTRAWORK )
//    	{
//    		para += _T("/O ");
//    	}

// 	if( _T("") != para )
// 		ATLPath::Append( str_execute_option, para );

	switch( installer_type )
	{
	case NUINSTALLER_TYPE_NSIS:
		{
			GetTempPath( 1024, target_path );
			ATLPath::Append( target_path, guid );
			CreateDirectory( target_path, NULL );

			TCHAR install_path[1024];
			Checked::tcscpy_s( install_path, 1024, path );
			ATLPath::RemoveFileSpec(install_path);

			wsprintf(execution_option, IDS_TIP_INSTALL_UNINSTALLER_OPTION, install_path );

			Checked::tcscpy_s( filename, 1024, ATLPath::FindFileName(path) );
			ATLPath::Append( target_path, filename );

			CopyFileToTemp(path, target_path );
			break;
		}

	case NUINSTALLER_TYPE_APP:
		_tcscpy_s(target_path, 1024, path );
		break;
	default:
		return FALSE;
		break;
	}

	// _?=δ ׻  ڿ 
	if( _T("") != para )
		wsprintf(str_execute_option, _T("%s %s"), para, execution_option);
	else
		wsprintf(str_execute_option, _T("%s"), execution_option);

	CString real_parameter = _T("");
	if( '\0' != param[0] )
	{
		real_parameter = param;
		real_parameter += _T(" ");
	}

	real_parameter += str_execute_option;

	MyRemoveEventCallback myRemoveEventCallback;

	launcherHandle->SetReadCallback( &myRemoveEventCallback );

 	UninstallPacket command;
 	command.type = PacketCommand_Uninstall;
	_tcscpy_s( command.path, tipbase::MAXPATH, target_path );
	_tcscpy_s( command.option, tipbase::MAXPATH, real_parameter );

 	launcherHandle->Write( (const BYTE *)&command, sizeof(UninstallPacket));
	launcherHandle->SetReadCallback(NULL);

	if( FALSE == WaitForHandleTipLauncher( myRemoveEventCallback.GetHandle(), TIPLAUNCHER_CHECK_TIME ) )
		return FALSE;

	if( myRemoveEventCallback.GetCommand() != PacketCommand_ExecuteStatus )
		return FALSE;

	if( myRemoveEventCallback.GetStatus() != 0 )
		return FALSE;

	return TRUE;
}

BOOL RemoveInstallModule::Install()
{
	GetCallback()->OnStart();
	CALLBACK_FINISHED_STATUS ret = CALLBACK_FINISHED_SUCCESS;
	
	ERRORINFO *errorInfo = NULL;

	NAVERAPP_INSTALL_STATUS install_status = GetInstallStatusWithGuid(GetGuid());
	if( NotInstalled != install_status )
	{
		if( FALSE == RemoveProgram( m_installer_type, GetGuid(), m_installer_path.c_str(), m_installer_param.c_str(), m_execute_option ) )
		{
			ret = CALLBACK_FINISHED_ERROR;
		}

		AgentDLLWrapper *agentDLL = AgentDLLManager::Find( GetGuid() );
		if( agentDLL )
		{
			CString msg;
			int code;

			if( TRUE == agentDLL->GetUninstallError( &code, &msg ) )
			{		
				errorInfo = MakeErrorInfo(code, (const TCHAR *)msg );
			}
		}
	}

	SetModuleStatus(ModuleStatusFINISHED);
	GetCallback()->OnFinished(ret, errorInfo);
	return TRUE;
}